unit AddInObj_01;

interface

uses
  PropPage_01,
  AddInLib, AddIn_MyFuncLib,
  ComServ, ComObj, ActiveX,
  SysUtils, Windows, Messages, Classes, Graphics, Controls, StdCtrls,
  ExtCtrls, Forms, StdVcl, AxCtrls, jpeg;


Const
  //  (2-   ProgID)
  ExtensionName_Comp = 'AddIn_V7MyScreenShot';
  //   DLL-  
  ExtensionName_Comp_Vers = '';
  // DLL-  
  dllName_Comp = ExtensionName_Comp+ExtensionName_Comp_Vers;



resourcestring
  strIsEnabled = 'IsEnabled,';  // 
  strEnable = 'Enable,';  // 
  strDisable = 'Disable,';  // 
  strScreenShot = 'ScreenShotToJPGFile,JPG';  // 

const
   { This GUID should be changed}
   //CLSID_AddInObject : TGUID = '{803C78D2-25BB-11d1-A4CB-004095E1DAEA}';
   CLSID_AddInObject : TGUID = '{29E9DA2F-7A99-409E-B47B-82FED06BD459}';

type

TProperties = ( propIsEnabled, LastProp );
TMethods = ( methEnable, methDisable, methScreenShot, LastMethod );

TAddInObject = class (TComObject, IDispatch, IInitDone, ISpecifyPropertyPages,
                                        ILanguageExtender,IPropertyLink)
      { Attributes }
    boolIsEnabled : Integer;
    pConn : IDispatch;

      { Interfaces }
    pErrorLog : IErrorLog;
    pEvent : IAsyncEvent;
    pProfile : IPropertyProfile;
    pStatusLine : IStatusLine;

    function LoadProperties: Boolean;
    procedure SaveProperties;
      { This function is useful in ILanguageExtender implementation }
    function TermString(strTerm: string; iAlias: Integer): string;
      {These two methods is convenient way to access function
       parameters from SAFEARRAY vector of variants }
    function GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
    procedure PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);

      { Interface implementation }
      { IInitDone implementation }
    function Init(pConnection: IDispatch): HResult; stdcall;
    function Done: HResult; stdcall;
    function GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
      { ISpecifyPropertyPages implementation }
    function GetPages(out Pages: TCAGUID) : HResult; stdcall;
      { ILanguageExtender implementation }
    function RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
    function GetNProps(var plProps: Integer): HResult; stdcall;
    function FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
    function GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
    function GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
    function SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
    function IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
    function IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
    function GetNMethods(var plMethods: Integer): HResult; stdcall;
    function FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
    function GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
    function GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
    function GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
    function HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
    function CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
    function CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
      { IPropertyLink implementation }
    function get_Enabled(var IsEnabled : Integer): HResult; stdcall;
    function put_Enabled(IsEnabled : Integer): HResult; stdcall;


        { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;
end;

implementation

function TAddInObject.LoadProperties: Boolean;
var
 iRes : Integer;
 varRead : OleVariant;
begin
 VarClear(varRead);
 { SImply cast OleVariant to Integer (VT_I4) }
 varRead := 0;
 iRes := pProfile.Read('Enabled:0',varRead,nil);
 if (iRes <> S_OK) then begin
    LoadProperties := False;
    Exit;
 end;
 boolIsEnabled := varRead;
 LoadProperties := True;
end;

procedure TAddInObject.SaveProperties;
var
  varSave : OleVariant;
begin
  varSave := boolIsEnabled;
  pProfile.Write('Enabled:0',varSave);
end;

function TAddInObject.TermString(strTerm: string; iAlias: Integer): string;
var
 iSemicolon: Integer;
begin
  iSemicolon := Pos(',',strTerm);
  if (iAlias = 0) then
    if (iSemicolon = 0) then
      TermString := strTerm
      else
        TermString := Copy(strTerm,1,iSemicolon-1)
    else { iAlias = 1}
      if (iSemicolon = 0) then
        TermString := ''
        else
          TermString := Copy(strTerm,iSemicolon+1,Length(strTerm) - iSemicolon);
end;

function TAddInObject.GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
var
 varGet : OleVariant;
begin
  SafeArrayGetElement(pArray,lIndex,varGet);
  GetNParam := varGet;
end;

procedure TAddInObject.PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);
begin
  SafeArrayPutElement(pArray,lIndex,varPut);
end;

{ IInitDone interface }

function TAddInObject.Init(pConnection: IDispatch): HResult; stdcall;
var
 iRes : Integer;
begin
  pConn := pConnection;
  pErrorLog := nil;
  pConnection.QueryInterface(IID_IErrorLog,pErrorLog);
  pEvent := nil;
  pConnection.QueryInterface(IID_IAsyncEvent,pEvent);
  pProfile := nil;
  iRes := pConnection.QueryInterface(IID_IPropertyProfile,pProfile);
  if (iRes = S_OK) then begin
     //pProfile.RegisterProfileAs('Sample AddIn Profile Name');
     pProfile.RegisterProfileAs(ExtensionName_Comp+' Profile Name');
     if (LoadProperties() <> True) then begin
        Init := E_FAIL;
        Exit;
     end;
  end;
  pStatusLine := nil;
  pConnection.QueryInterface(IID_IStatusLine,pStatusLine);
  Init := S_OK;
end;

function TAddInObject.Done: HResult; stdcall;
begin
  SaveProperties();
  if (pErrorLog <> nil) then
    pErrorLog._Release();
  if (pEvent <> nil) then
    pEvent._Release();
  if (pProfile <> nil) then
    pProfile._Release();
  if (pStatusLine <> nil) then
    pStatusLine._Release();
  Done := S_OK;
end;

function TAddInObject.GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
var
  varInfo : OleVariant;
begin
  varInfo := '2000';
  PutNParam(pInfo,0,varInfo);
  GetInfo := S_OK;
end;

{ ISpecifyPropertyPages interface }

function TAddInObject.GetPages(out Pages: TCAGUID) : HResult; stdcall;
begin
  Pages.cElems := 1;
  Pages.pElems := CoTaskMemAlloc(SizeOf(TGUID));
  (Pages.pElems)[0] := Class_AddInPropPage;
  GetPages := S_OK;
end;

{ ILanguageExtender interface }

function TAddInObject.RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
begin
  //bstrExtensionName := 'AddIn_Example01';
  bstrExtensionName := ExtensionName_Comp;
  RegisterExtensionAs := S_OK;
end;

function TAddInObject.GetNProps(var plProps: Integer): HResult; stdcall;
begin
  plProps := Integer(LastProp);
  GetNProps := S_OK;
end;

function TAddInObject.FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
begin
  plPropNum := -1;

  if (bstrPropName = TermString(strIsEnabled,0)) then plPropNum := 0;
  if (bstrPropName = TermString(strIsEnabled,1)) then plPropNum := 0;

  if (plPropNum = -1) then begin
     FindProp := S_FALSE;
     Exit;
  end;

  FindProp := S_OK;
end;

function TAddInObject.GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
begin
  pbstrPropName := '';
  case TProperties(lPropNum) of
    propIsEnabled:
      begin
        pbstrPropName := TermString(strIsEnabled,lPropAlias);
      end;
    else
      begin
        GetPropName := S_FALSE;
        Exit;
      end;
  end;
  GetPropName := S_OK;
end;

function TAddInObject.GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
begin
  VarClear(pvarPropVal);
  case TProperties(lPropNum) of
    propIsEnabled:
      begin
        pvarPropVal := boolIsEnabled;
      end;
    else
      begin
        GetPropVal := S_FALSE;
        Exit;
      end;
  end;
  GetPropVal := S_OK;
end;

function TAddInObject.SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
begin
  case TProperties(lPropNum) of
    propIsEnabled:
      begin
        boolIsEnabled := varPropVal;
      end;
    else
      begin
        SetPropVal := S_FALSE;
        Exit;
      end;
  end;
  SetPropVal := S_OK;
end;

function TAddInObject.IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
begin
  case TProperties(lPropNum) of
    propIsEnabled:
      begin
        pboolPropRead := 1;
      end;
    else
      begin
        IsPropReadable := S_FALSE;
        Exit;
      end;
  end;
  IsPropReadable := S_OK;
end;

function TAddInObject.IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
begin
  case TProperties(lPropNum) of
    propIsEnabled:
      begin
        pboolPropWrite := 1;
      end;
    else
      begin
       IsPropWritable := S_FALSE;
       Exit;
      end;
  end;
  IsPropWritable := S_OK;
end;

function TAddInObject.GetNMethods(var plMethods: Integer): HResult; stdcall;
begin
  plMethods := Integer(LastMethod);
  GetNMethods := S_OK;
end;

function TAddInObject.FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
begin
  plMethodNum := -1;
  if (bstrMethodName = TermString(strEnable,0)) then plMethodNum := 0;
  if (bstrMethodName = TermString(strEnable,1)) then plMethodNum := 0;
  if (bstrMethodName = TermString(strDisable,0)) then plMethodNum := 1;
  if (bstrMethodName = TermString(strDisable,1)) then plMethodNum := 1;

  //  
  if (bstrMethodName = TermString(strScreenShot,0)) then plMethodNum := 2;
  if (bstrMethodName = TermString(strScreenShot,1)) then plMethodNum := 2;


  if (plMethodNum = -1) then begin
     FindMethod := S_FALSE;
     Exit;
  end;
  FindMethod := S_OK;
end;

function TAddInObject.GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
begin
  pbstrMethodName := '';
  case TMethods(lMethodNum) of
    methEnable:
      begin
        pbstrMethodName := TermString(strEnable,lMethodAlias);
      end;
    methDisable:
      begin
        pbstrMethodName := TermString(strDisable,lMethodAlias);
      end;
    methScreenShot: //  
      begin
        pbstrMethodName := TermString(strScreenShot,lMethodAlias);
      end;
    else
      begin
       GetMethodName := S_FALSE;
       Exit;
      end;
  end;
  GetMethodName := S_OK;
end;

function TAddInObject.GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
begin
  plParams := 0;
  case TMethods(lMethodNum) of
    methEnable:
      begin
        plParams := 0;
      end;
    methDisable:
      begin
        plParams := 0;
      end;
    methScreenShot:
      begin
        plParams := 2;
      end;
    else
      begin
        GetNParams := S_FALSE;
        Exit;
      end;
  end;
  GetNParams := S_OK;
end;

function TAddInObject.GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
begin
  { Ther is no default value for any parameter }
  VarClear(pvarParamDefValue);
  GetParamDefValue := S_OK;
end;

function TAddInObject.HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
begin
  pboolRetValue := 0;
  case TMethods(lMethodNum) of
    methScreenShot: //  (, )
      begin
        pboolRetValue := -1;
      end;
  else
    begin
       HasRetVal := S_FALSE;
       Exit;
    end;
  end;
  HasRetVal := S_OK;
end;

function TAddInObject.CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;

begin
  case TMethods(lMethodNum) of
    methEnable:
      begin
        boolIsEnabled := 1;
      end;
    methDisable:
      begin
        boolIsEnabled := 0;
      end;

    else
      begin
       CallAsProc := S_FALSE;
       Exit;
      end;
  end;
  CallAsProc := S_OK;
end;

function TAddInObject.CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;

var
  FileName : String;
  CompressPercent : Integer;
  AHandle : THandle;
  AImage : TJPEGImage;
  fBitmap: TBitmap;
  DC: HDC;
  Rect: TRect;

begin
  case TMethods(lMethodNum) of
    methScreenShot:  //   ( ,)
      begin
        pvarRetValue:=0;
        AHandle := GetDesktopWindow;
        DC := GetDC(AHandle);
        FileName := Trim(GetNParam(paParams,0));
        CompressPercent := GetNParam(paParams,1);

        if DC <> 0 then begin
            TRY
                AImage := TJPEGImage.Create;
                fBitmap := TBitmap.Create;
                if GetClientRect(AHandle, Rect) then begin
                        fBitmap.Width := Rect.Right - Rect.Left;
                        fBitmap.Height := Rect.Bottom - Rect.Top;
                        fBitmap.PixelFormat := pf32bit;
                        if BitBlt(fBitmap.Canvas.Handle, 0, 0, fBitmap.Width, fBitmap.Height, DC, 0, 0, SRCCOPY) then begin
                                AImage.Assign(fBitmap);
                                AImage.CompressionQuality := CompressPercent;
                                AImage.Compress;
                                if length(ExtractFilePath(FileName))>0 then begin
                                        if sp_ItsNotReadOnlyDisk(FileName) then begin
                                                TRY
                                                        AImage.SaveToFile(FileName);
                                                        pvarRetValue:=1;
                                                EXCEPT
                                                        pvarRetValue:=0;
                                                END;
                                        end;
                                end;
                        end;
                end;
            FINALLY
                if AImage<>NIL then AImage.Free;
                if fBitmap<>NIL then fBitmap.Free;
                ReleaseDC(AHandle, DC);
            END;
        end;
      end;
    else
      begin
        CallAsFunc := S_FALSE;
        Exit;
      end;
  end;
  CallAsFunc := S_OK;
end;

function TAddInObject.get_Enabled(var IsEnabled : Integer): HResult; stdcall;
begin
  IsEnabled := boolIsEnabled;
  get_Enabled := S_OK;
end;

function TAddInObject.put_Enabled(IsEnabled : Integer): HResult; stdcall;
begin
  boolIsEnabled := IsEnabled;
  {
  if (boolIsEnabled = 0) then
    pEvent.ExternalEvent('','','0')
    else pEvent.ExternalEvent('','','1');
  }  
  put_Enabled := S_OK;
end;

function TAddInObject.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;


initialization

ComServer.SetServerName('AddIn');
TComObjectFactory.Create(ComServer,TAddInObject,CLSID_AddInObject,
                        dllName_Comp,'V7 AddIn 2.0',ciMultiInstance);

end.





